﻿using System;
using System.Collections.ObjectModel;
using System.IO;

using Vintagestory.API.Client;
using Vintagestory.API.Common;
using Vintagestory.API.MathTools;

using ProtoBuf;

using Newtonsoft.Json;

namespace Automap
{
	/// <summary>
	/// Actual Physical Point in space - that is interesting.
	/// </summary>
	[ProtoContract(ImplicitFields = ImplicitFields.None)]
	public struct PointOfInterest
	{
		[DisplayName(0, "Name")]
		[ProtoMember(1)]
		public string Name;

		[DisplayName(2, "Notes")]
		[ProtoMember(2)]
		public string Notes;

		[DisplayName(1, "Loc.")]
		[ProtoIgnore]
		public string PrettyLocation;

		[ProtoMember(3)]
		public BlockPos Location;

		[DisplayName(3, "Time")]
		[ProtoMember(4)]
		public DateTime Timestamp;


		[DisplayName(4, "Dest")]
		[ProtoMember(5)]
		public BlockPosJson Destination;


	}

	public class PointsOfInterest : KeyedCollection<BlockPos, PointOfInterest>
	{
		protected override BlockPos GetKeyForItem(PointOfInterest item)
			=> item.Location;

		internal void AddReplace(PointOfInterest poi)
		{
			if (Contains(poi.Location))
				Remove(poi.Location);

			Add(poi);
		}
	}

}

